Loading...
Searching...
No Matches
type_traits.h File Reference
`#include "platform.h"`
`#include "nullptr.h"`
`#include "static_assert.h"`
`#include <stddef.h>`
`#include <stdint.h>`
`#include "private/type_traits_cpp03.h"`

Go to the source code of this file.

## Classes

struct | etl::integral_constant< T, VALUE >
| integral_constant More...
struct | etl::bool_constant< BValue >
struct | etl::negation< T >
| negation More...
struct | etl::remove_reference< T >
| remove_reference More...
struct | etl::remove_reference< T & >
struct | etl::remove_pointer< T >
| remove_pointer More...
struct | etl::remove_pointer< T * >
struct | etl::remove_pointer< const T * >
struct | etl::remove_pointer< volatile T * >
struct | etl::remove_pointer< const volatile T * >
struct | etl::remove_pointer< T *const >
struct | etl::remove_pointer< const T *const >
struct | etl::remove_pointer< volatile T *const >
struct | etl::remove_pointer< const volatile T *const >
struct | etl::add_pointer< T >
| add_pointer More...
struct | etl::is_const< T >
| is_const More...
struct | etl::is_const< const T >
struct | etl::is_const< const volatile T >
struct | etl::remove_const< T >
| remove_const More...
struct | etl::remove_const< const T >
struct | etl::add_const< T >
| add_const More...
struct | etl::add_const< const T >
struct | etl::is_volatile< T >
| is_volatile More...
struct | etl::is_volatile< volatile T >
struct | etl::is_volatile< const volatile T >
struct | etl::remove_volatile< T >
| remove_volatile More...
struct | etl::remove_volatile< volatile T >
struct | etl::add_volatile< T >
| add_volatile More...
struct | etl::add_volatile< volatile T >
struct | etl::remove_cv< T >
| remove_cv More...
struct | etl::add_cv< T >
| add_cv More...
struct | etl::remove_cvref< T >
| remove_cvref More...
struct | etl::is_integral< T >
| is_integral More...
struct | etl::is_integral< bool >
struct | etl::is_integral< char >
struct | etl::is_integral< unsigned char >
struct | etl::is_integral< signed char >
struct | etl::is_integral< wchar_t >
struct | etl::is_integral< short >
struct | etl::is_integral< unsigned short >
struct | etl::is_integral< int >
struct | etl::is_integral< unsigned int >
struct | etl::is_integral< long >
struct | etl::is_integral< unsigned long >
struct | etl::is_integral< long long >
struct | etl::is_integral< unsigned long long >
struct | etl::is_integral< const T >
struct | etl::is_integral< volatile T >
struct | etl::is_integral< const volatile T >
struct | etl::is_signed< T >
| is_signed More...
struct | etl::is_signed< char >

## Namespaces

namespace | etl

## Macros

#define | ETL_IS_CHAR_TYPE(type)
#define | ETL_IS_NOT_CHAR_TYPE(type)
#define | ETL_IS_POINTER_TYPE(type)
#define | ETL_IS_NOT_POINTER_TYPE(type)
#define | ETL_TARGET_IS_TRIVIALLY_COPYABLE(type)
#define | ETL_TARGET_IS_NOT_TRIVIALLY_COPYABLE(type)

## Typedefs

typedef integral_constant< bool, false > | etl::false_type
| integral_constant specialisations
typedef integral_constant< bool, true > | etl::true_type

## Variables

template<typename T, T VALUE>
const T | etl::integral_constant< T, VALUE >::value

## Macro Definition Documentation

## ETL_IS_CHAR_TYPE

#define ETL_IS_CHAR_TYPE | ( |  | type | ) |

Value:
(etl::is_same<char, type>::value || etl::is_same<signed char, type>::value || etl::is_same<unsigned char, type>::value)

## ETL_IS_NOT_CHAR_TYPE

#define ETL_IS_NOT_CHAR_TYPE | ( |  | type | ) |

Value:
(!ETL_IS_CHAR_TYPE(type))
type

## ETL_IS_NOT_POINTER_TYPE

#define ETL_IS_NOT_POINTER_TYPE | ( |  | type | ) |

Value:
(!ETL_IS_POINTER_TYPE(type))

## ETL_IS_POINTER_TYPE

#define ETL_IS_POINTER_TYPE | ( |  | type | ) |

Value:
(etl::is_pointer<type>::value)

## ETL_TARGET_IS_NOT_TRIVIALLY_COPYABLE

#define ETL_TARGET_IS_NOT_TRIVIALLY_COPYABLE | ( |  | type | ) |

Value:
(!ETL_TARGET_IS_TRIVIALLY_COPYABLE(type))

## ETL_TARGET_IS_TRIVIALLY_COPYABLE

#define ETL_TARGET_IS_TRIVIALLY_COPYABLE | ( |  | type | ) |

Value:
(etl::is_trivially_copyable< typename etl::iterator_traits<type>::value_type>::value)